// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////////////////////////////
// Point

function Point (x, y)
{
	this.x = x;
	this.y = y;
}


//////////////////////////////////////////////////////////////////////
// Rect

function Rect (left, top, right, bottom)
{
	this.left = left;
	this.right = right;
	this.top = top;
	this.bottom = bottom;
}

function pointInRect (x, y)
{
	if (x >= this.left && x <= this.right && y >= this.top && y <= this.bottom) {
		return true;
	}
	return false;
}

function RectWidth ()
{
	return this.right - this.left + 1;
}

function RectHeight ()
{
	return this.bottom - this.top + 1;
}

Rect.prototype.pointIn = pointInRect;
Rect.prototype.width = RectWidth;
Rect.prototype.height = RectHeight;


//////////////////////////////////////////////////////////////////////
// AnArea

function AnArea (rect, data)
{
    this.rect = rect;
    this.data = data;
}


//////////////////////////////////////////////////////////////////////
// MapOfAreas

function MapOfAreas ()
{
    this.list = new Array ();
    for (var i = 0; i < arguments.length; i++) {
        if (arguments[i])
            this.list[i] = arguments[i];
    }
}

function searchRectByPointInMapOfAreas (view, x, y)
{
	var i, a;
	for (i = 0; i < this.list.length; i++) {
		a = this.list[i];
        if (a.rect.pointIn(x, y)) {
            return a;
        }
	}
	return false;
}

function lengthInMapOfAreas ()
{
    return this.list.length;
}

function atInMapOfAreas (i)
{
    return this.list[i];
}

MapOfAreas.prototype.searchRectByPoint = searchRectByPointInMapOfAreas;
MapOfAreas.prototype.length = lengthInMapOfAreas;
MapOfAreas.prototype.at = atInMapOfAreas;

//////////////////////////////////////////////////////////////////////
// SysCompositeImage ()

function SysCompositeImage (label, html)
{
    this.label = label;
    this.html = html;
}

function getHtmlFromSysCompositeImage ()
{
    var i, j = '';
    for (i = 0; i < this.html.length(); i++) {
        j += eval(this.html.at(i));
    }
    return j;
}

SysCompositeImage.prototype.getHtml = getHtmlFromSysCompositeImage;


//////////////////////////////////////////////////////////////////////
// SysComponentInfo

function SysComponentInfo (id, label, image, info, alertobjs)
{
    this.id = id;
    this.label = label;
    this.image = image;
    this.info = false;
    this.alerts = false;

    if (arguments.length > 3) {
        this.info = info;
        if (arguments.length > 4) {
            this.alerts = alertobjs;
        }
    }
}


//////////////////////////////////////////////////////////////////////
// SysModelView

function SysModelView (title, label, simpleimg, complximg, defimg, mapofareas, alertobjs)
{
    this.title = title;
    this.label = label;
    this.simpleimage = false;
    this.complximage = false;
    this.defImage = false;
    this.magnifymap = false;
    this.alerts = false;

    if (arguments.length > 2) {
        this.simpleimage = simpleimg;
        this.complximage = complximg;
        this.defImage = defimg;
        if (arguments.length > 5) {
            this.magnifymap = mapofareas;
        }
        if (arguments.length > 6) {
            this.alerts = alertobjs;
        }
    }
}


//////////////////////////////////////////////////////////////////////
// SysModel

var chassis_tower = 't';
var chassis_rackmount = 'r';

function SysModel (modelimage, chassistype)
{
    this.modleimage = modelimage;
    this.chassistype = chassistype;
    this.view = new Array ();
    this.viewidx = new Array ();
}

function getViewArrayInSysModel (view)
{
    if (this.view[view]) {
        return this.view[view];
    }
    return false;
}

function attachViewInSysModel (view, objView)
{
    var i = this.viewidx.length;
    this.view[view] = objView;
    this.viewidx[i] = view;
}

function confirmViewInSysModel (view)
{
    return this.view[view] ? view : false;
}

function totalViewInSysModel ()
{
    return this.viewidx.length;
}

function viewAtInSysModel (i)
{
    if (this.viewidx[i]) {
        return this.viewidx[i];
    }
    return false;
}

function getViewAtInSysModel (i)
{
    if (this.viewidx[i]) {
        if (this.view[this.viewidx[i]]) {
            return this.view[this.viewidx[i]];
        }
    }
    return false;
}

SysModel.prototype.totalView = totalViewInSysModel;
SysModel.prototype.getView = getViewArrayInSysModel;
SysModel.prototype.attachView = attachViewInSysModel;
SysModel.prototype.confirmView = confirmViewInSysModel;
SysModel.prototype.viewAt = viewAtInSysModel;
SysModel.prototype.getViewAt = getViewAtInSysModel;


//////////////////////////////////////////////////////////////////////
// SysBackplane

function SysBackplane (model, bkimg, compon, bkplsensor, baysensor, remapcfgTyp)
{
    this.model = model;
    this.backplaneimage = bkimg;
    this.component = compon;
    this.backplanesensors = false;
    this.baysensors = false;
    this.remapcfgtype = false;
    if (bkplsensor) {
        this.backplanesensors = bkplsensor;
    }
    if (baysensor) {
        this.baysensors = baysensor;
    }
    if (remapcfgTyp) {
        this.remapcfgtype = remapcfgTyp;
    }
}

//////////////////////////////////////////////////////////////////////
// SysPower

function SysPower (model, compon, modsensor, pwsensor)
{
    this.model = model;
    this.component = compon;
    this.powersensors = false;
    this.modulesensors = false;
    if (modsensor) {
        this.modulesensors = modsensor;
    }
    if (pwsensor) {
        this.powersensors = pwsensor;
    }
}
